package com.example.demo_fingerprint_morpho.fragment;

import android.os.Bundle;
import android.os.Handler;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.ScrollView;
import android.widget.TextView;

import androidx.fragment.app.Fragment;


import com.example.demo_fingerprint_morpho.FileUtils;
import com.example.demo_fingerprint_morpho.MainActivity;
import com.example.demo_fingerprint_morpho.R;
import com.rscja.deviceapi.FingerprintWithMorpho;
import com.rscja.utility.StringUtility;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;


public class TemplateVerify extends Fragment implements View.OnClickListener{
    private MainActivity mContext;

    private static final String TAG = "TemplateVerify";
    Button btnIdent;
    ListView lsTemplate;
    TextView tvTip ;
    TextView tvInfoMsg ;
    ScrollView scroll2;
    private HashMap<String,String> hashMap;
    String oldMsg="";
    String path;
    Handler handler=new Handler();
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_template_verify2, container, false);
    }
    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
        mContext = (MainActivity) getActivity();
        init();
    }
    private void init() {

        tvTip= (TextView) getView().findViewById(R.id.tvTip);
        tvInfoMsg= (TextView) getView().findViewById(R.id.tvInfoMsg);
        btnIdent = (Button) getView().findViewById(R.id.btnIdent);

        scroll2=(ScrollView)getView().findViewById(R.id.scroll2);
        lsTemplate = (ListView) getView().findViewById(R.id.lsTemplate);

        btnIdent.setOnClickListener(this);
        tvTip.setText(FileUtils.PATH);
        lsTemplate.setVerticalScrollBarEnabled(true);
        initListTemplate();

        lsTemplate.setOnItemClickListener(new AdapterView.OnItemClickListener(){
            @Override
            public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
                //获得选中项的HashMap对象
                String key=(String)lsTemplate.getItemAtPosition(arg2);
                path=hashMap.get(key);

            }});

        mContext.mFingerprint.setTemplateVerifyCallBack(new FingerprintWithMorpho.TemplateVerifyCallBack() {
            @Override
            public void messageInfo(String msg, int i) {
                if(!oldMsg.equals(msg)) {
                    String str1=tvInfoMsg.getText().toString();
                    String strMsg=str1+msg+".\r\n";
                    tvInfoMsg.setText(strMsg);
                    oldMsg=msg;
                    scrollToBottom();
                }
            }
            @Override
            public void onComplete(boolean result, int i) {
                btnIdent.setEnabled(true);
                if(result){
                    mContext.playSound(1);
                }else{
                    mContext.playSound(2);
                }
            }
        });
    }

    private void initListTemplate(){
        hashMap= FileUtils.ReadFileName();
        List<String> data = new ArrayList<String>();
        Iterator iter = hashMap.entrySet().iterator();
        while (iter.hasNext()) {
            Map.Entry entry = (Map.Entry) iter.next();
            Object key = entry.getKey();
            data.add(key.toString());
        }
        ArrayAdapter<String> adapter= new ArrayAdapter<String>(getActivity(),R.layout.listitem,R.id.list_item,data);
        lsTemplate.setAdapter(adapter);
    }

    public void scrollToBottom() {
        handler.post(new Runnable() {
            @Override
            public void run() {
                scroll2.fullScroll(ScrollView.FOCUS_DOWN);
            }
        });
    }

    @Override
    public void onClick(View view) {
        switch (view.getId()){
            case R.id.btnIdent:
                if(path==null || path.length()<0)
                    return;
                String temp=FileUtils.ReadFile(path);
                if(!temp.isEmpty()) {
                    byte[] templateData = StringUtility.hexStringToBytes(temp);
                    mContext.mFingerprint.startTemplateVerify(templateData,0);
                    btnIdent.setEnabled(false);
                }
                break;
        }
    }


}
